Bug 239656 - GFS2: gfs2_tool layout not implemented: regression from gfs1
GFS2: gfs2_tool layout not implemented: regression from gfs1
Product: Fedora
Classification: Fedora
Component: gfs2-utils (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Andrew Price
: FutureFeature
Depends On: 221301
  Show dependency treegraph
Reported: 2007-05-10 07:01 EDT by Steve Whitehouse
Modified: 2008-08-15 14:39 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2008-08-15 14:39:17 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Project proposal (2.44 KB, text/plain)
2007-07-04 17:31 EDT, Andrew Price
no flags Details

  None (edit)
Description Steve Whitehouse 2007-05-10 07:01:37 EDT
+++ This bug was initially created as a clone of Bug #221301 +++

GFS1 has the ability to print out all the blocks their
location for a particular file.
This is extremely useful information when doing performance 
analysis of the file system and the underlying block device.

Print out the ondisk layout for a file:
  gfs_tool layout <filename> [buffersize]

This option is not currently present in gfs2.
bear-03[11:36am]#gfs2_tool layout
gfs2_tool: unknown action: layout

-- Additional comment from rpeterso@redhat.com on 2007-02-28 17:31 EST --
I can probably do this with the debugfs file system.  In light of my
other debugfs changes for bz 228540, I'm reassigning to myself.

-- Additional comment from swhiteho@redhat.com on 2007-03-01 03:57 EST --
Abhi started looking at this the other day. Its not top of the list right now
and I don't think we need any kernel support for it. We should be able to simply
parse the fs from userspace.
Comment 1 Steve Whitehouse 2007-05-10 07:08:30 EDT
This is a new bug I've created to track Andy's student project. I've cloned it
off the RHEL bug since making it an FC devel bug means I can assign it to Andy

This is a way for us to track things and I hope provide a way for us to keep in
touch with Andy over the course of the next 12 months.

Andy, you'll spot that some of the previous discussion in the bug looks a little
confusing, but you can ignore that I think. It would be a good idea to attach
the project blurb once agreed with your supervisor I think.
Comment 2 Andrew Price 2007-07-04 17:31:30 EDT
Created attachment 158556 [details]
Project proposal

I've attached the project proposal blurb that I submitted to uni. As you can
see it's pretty vague and there are a few avenues open to me. Please feel free
to steer the project in a direction that would be most useful for the
GFS2/cluster development. I'm currently trying to educate myself about things
like blktrace, libgfs2 and Linux filesystems in general and I might start
playing around with some code to experiment soon but I don't think I'll have
any working code to look at for a while yet.

To give a picture of the schedule I'll be working to, the structure of our comp
sci projects dictates that I have to do research over the summer, submit an
assessed project spec document around October and then have the code,
dissertation etc. finished for May/June 2008. After that, anything goes, so if
I end up with something useful I'll most likely carry on maintaining it
alongside my other open source projects.

I hope that introduction was helpful. I look forward to getting started.
Comment 3 Steve Whitehouse 2007-07-13 04:04:16 EDT
Yes, that looks good. Let us know if you need any info on the internals of the
Comment 4 Steve Whitehouse 2007-07-13 11:17:06 EDT
Also on the visualization front, vtk or matplotlib might be the things to chose,
as they should do most of the hard work for you on that front.
Comment 5 Andrew Price 2007-10-30 13:57:46 EDT
Just a quick update. I've now handed in my "Initial Document" for the project so
the first boring bit is out of the way and I can get on with writing some code.
Once I've got something working I'll make it available.
Comment 6 Andrew Price 2008-05-02 08:10:46 EDT
I'm pleased to say that my student project has finally reached a point where I
can make the code available. Bear in mind that it's not by any means 'complete'
and it should be thought of as a prototype on which to build and improve. It may
not even be very useful at the moment. So if you have any bugs to report feel
free to email me and I'll see to them when I have fewer dissertations to write :-)

That said, it should be minimally usable in its current form and I'd like to get
your feedback on any of its aspects. Note that it currently misses out a lot of
gfs2's metadata block types e.g. it doesn't read the rindex to discover the
resource groups yet but this will be implemented in due course.

I've made the git repository available here:

git clone http://andrewprice.me.uk/git/askant.git

Unfortunately I cannot run gitweb or a git daemon on that server so please let
me know if there is somewhere more suitable where it could be hosted long-term.

I've attempted to provide useful docs with askant so the README, INSTALL,
PLUGINAPI files and './setup.py --help-commands' should be good places to start.
A man page and better code comments are on my (long) to-do list.

Thank you for your patience and I hope you find my little program has some
potential to be useful for Linux file system developers :-)
Comment 7 Steve Whitehouse 2008-07-02 11:44:55 EDT
Fabio, could we add Andy's project (see comment #6) into our main code base
somehow? I'm worried that it will be lost if we don't have it in the same place
as the rest of the code.
Comment 8 Fabio Massimo Di Nitto 2008-07-02 14:13:21 EDT
Hi Steven,

I will look at it soon.
Comment 9 Andrew Price 2008-07-02 18:30:38 EDT
Hi Steve,

I had a chat with Fabio on IRC and the outcome was that I'll relicense Askant as
GPLv2+, push my outstanding work to my git repository and let Fabio know when
it's ready to be imported. The commit history will probably have to be
discarded, but I think that's acceptable.

Fabio asked if it should be shipped in the standard packages (?) but I'm not
sure how to answer that as they're not my packages :) Perhaps we can clear that
up here.
Comment 10 Steve Whitehouse 2008-07-03 05:19:13 EDT
Ok, sounds good. I think we can close this bug then.
Comment 11 Andrew Price 2008-07-05 21:15:15 EDT
My remaining changes have been pushed and it's now under GPL2+, as discussed.
Comment 12 Andrew Price 2008-08-15 14:39:17 EDT
As per comment #10 I'm going to close this bug now. The only reason we'd use it would be for communication and email and IRC are more suitable for that. Plus I've graduated and askant is now in the cluster git repository (andyp_askant branch initially). Thanks all.

Note You need to log in before you can comment on or make changes to this bug.